# 使用说明
1） 在`build.gradle`中进行配置。
 ```groovy
 buildscript {
    repositories {
        mavenLocal()
        mavenCentral()
    }
    dependencies {
        classpath "org.bdware.bdcontract:ypk-deploy-tool:0.5.0"
    }
}
//....
task deploy(dependsOn: ["xxx"]) {
    doLast {
        org.bdware.ypkdeploy.HTTPTool.batchRun("./xxx/deployconfig.json", true)
    }
}
```
2） 配置`./xxx/deployconfig.json`文件。
参数说明：

`agentAddress`为运行了bdagent的服务端的ip:port

`privateKey/publicKey`为有部署权限的一组SM2KeyPair

`ypkPath`是待部署的ypk路径。

`deployconfig.json`配置示例：
```json
{
  "agentAddress": "192.168.x.x:18000",
  "privateKey": "5895c18430dd...",
  "publicKey": "04d1924329f72ced14...",
  "ypkPath":  "/path/to/todeploy.ypk",
  "killBeforeStart": "ContractName",
  "createParam": {
  }
}
```