import org.apache.http.HttpEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.mime.MultipartEntityBuilder;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.bouncycastle.crypto.CryptoException;
import org.bouncycastle.pqc.math.linearalgebra.ByteUtils;
import org.junit.Test;
import org.zz.gmhelper.SM2KeyPair;
import org.zz.gmhelper.SM2Util;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.nio.charset.StandardCharsets;

public class HttpUploadTest {
    @Test
    public void run() {
        String url = "http://%s/Upload?%s&sign=%s";
        File file = new File("/Users/huaqiancai/BDWare/bdcontract-bundle/agent-backend/BDWareProjectDir/publicCompiled/DoipDist-0.3.3.ypk");
        String argWithoutSig = "path=%s&fileName=%s&isPrivate=true&contractID=%s&order=%d&count=%d&pubKey=%s";

        SM2KeyPair keyPair;
        try {
            keyPair = SM2KeyPair.fromJson("{\"privateKey\":\"589d94ee5688358a1c5c18430dd9c75097ddddebf769f139da36a807911d20f8\",\"publicKey\":\"04d1924329f72ced148f6f333fb985ccbaa31b1e3aacf10be5f43d4a4ff5ad88899a005e79e37fc06993e1d66ada8cf8b711cb36f59538bb7d3e39e70fa9360ddd\"}");
        } catch (Exception e) {
            e.printStackTrace();
            return;
        }
        String pubKey = keyPair.getPublicKeyStr();
        int trunc = 300 * 1024;
        byte[] buff = new byte[trunc];
        int order = 0;
        int count = (int) ((file.length() - 1) / (trunc)) + 1;
        try {
            FileInputStream fin = new FileInputStream(file);
            for (int len = 0; (len = fin.read(buff)) > 0; order++) {
                CloseableHttpClient client = HttpClients.createDefault();
                String arg = String.format(argWithoutSig, "/ypks", file.getName(), "CodeRepo", order, count, pubKey);
                String sign = ByteUtils.toHexString(SM2Util.sign(keyPair.getPrivateKeyParameter(), arg.getBytes(StandardCharsets.UTF_8)));
                String urlStr = String.format(url, "127.0.0.1:18000", arg, sign);
                System.out.println("urlStr:" + urlStr);
                HttpPost httpPost = new HttpPost(urlStr);
                MultipartEntityBuilder builder = MultipartEntityBuilder.create();
                if (len == trunc)
                    builder.addBinaryBody("file", buff, ContentType.APPLICATION_OCTET_STREAM, file.getName());
                else {
                    byte[] bu = new byte[len];
                    System.arraycopy(buff, 0, bu, 0, len);
                    builder.addBinaryBody("file", bu, ContentType.APPLICATION_OCTET_STREAM, file.getName());

                }
                HttpEntity multipart = builder.build();
                httpPost.setEntity(multipart);
                CloseableHttpResponse response = client.execute(httpPost);
                ByteArrayOutputStream bo = new ByteArrayOutputStream();
                response.getEntity().writeTo(bo);
                System.out.println(order + "/" + count + " " + bo);
                client.close();
            }
        } catch (IOException | CryptoException e) {
            e.printStackTrace();
        }
    }
}
